#version 100

precision highp float;

varying vec2 vertex_texture;
varying vec3 vertex_normal;

uniform sampler2D sampler;

void main(void) {
    vec3 light = vec3(0, 10, 10); // in view coordinates
    vec4 color = vec4(0.0, 0.0, 0.0, 1.0);

    vec3 normal = normalize(vertex_normal);
    float intensity = dot(light, normal);

    if (intensity > 0.0)
		color = vec4(1.0, 1.0, 1.0, 1.0);
	else
		color = vec4(0.45, 0.45, 0.45, 1.0);

    gl_FragColor = color * texture2D(sampler, vertex_texture);
}
