#version 100

precision highp float;

attribute vec3 vertex;
attribute vec3 normal;
attribute vec2 texture;
attribute vec4 weights;
attribute vec4 bones;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 skinning[50];

varying vec2 vertex_texture;
varying vec3 vertex_normal;

void main(void) {
	vec4 bone = bones;
	vec4 weight = weights;

	vec4 tempP = vec4(0.0, 0.0, 0.0, 0.0);
	//vec4 tempN = vec4(0.0, 0.0, 0.0, 0.0);
	mat4 tempM;

	for(int i = 0; i < 4; i++) {
		tempM = weight.x / 127.0 * skinning[int(bone.x)];
		tempP += tempM * vec4(vertex, 1.0);
		//tempN += tempM * vec4(normal, 0.0);

		weight = vec4(weight.yzw, weight.x); // rotate weight
		bone = vec4(bone.yzw, bone.x); // rotate bone
    }

    vertex_texture = texture;
	vertex_normal = mat3(model) * normal;
	//vertex_normal = mat3(view) * vec3(tempN); <- broken hands!

	gl_Position = projection * view * model * tempP;
}
